package com.grack.hdcp;

import java.lang.reflect.Array;

public class SecretKey {

	private long[] secretKey;

	public SecretKey(long[] secretKey) {
		super();
		this.secretKey = secretKey;
	}
	
	public long calculateKey(PublicKey otherPublicKey) {
		long result = 0;
		long otherPublicKeyValue = otherPublicKey.getPublicKey();

		for (int i = 0; i < secretKey.length; i++) {
			if ((otherPublicKeyValue & (1L << i)) > 0)
				result += secretKey[i];
		}

		return result;
	}

	public long[] getKey() {
		return secretKey;
	}

	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("[");
		
		for ( long value : secretKey ) {
			builder.append(value);
			builder.append( "," );
		}
		builder.setLength(builder.length() - 1);
		builder.append("]");
		return builder.toString();
	}
	
	public boolean equals(Object other) {
		SecretKey secretKey = (SecretKey) other;
		for ( int i = 0; i < secretKey.secretKey.length; i++ )
			if ( this.secretKey[ i ] != secretKey.secretKey[ i ] )
				return false;
		
		return true;
	}
}
