package com.grack.hdcp.tests;

import com.grack.hdcp.HdcpDevice;
import com.grack.hdcp.HdcpSystem;
import com.grack.hdcp.PublicKey;

import junit.framework.TestCase;

public class TestHdcpDevice extends TestCase {
	public void testCalculate() {
		HdcpSystem system = new HdcpSystem(4);
		
		HdcpDevice dev1 = new HdcpDevice(system, new long[] { 26, 19, 12, 7 }, 
				new PublicKey( system, new int[] { 1, 2 } ) );
		HdcpDevice dev2 = new HdcpDevice(system, new long[] { 13, 13, 22, 5 }, 
				new PublicKey( system, new int[] { 2, 4 } ) );
		HdcpDevice dev3 = new HdcpDevice(system, new long[] { 22, 16, 5, 19 }, 
				new PublicKey( system, new int[] { 1, 3 } ) );
		HdcpDevice dev4 = new HdcpDevice(system, new long[] { 9, 10, 15, 17 }, 
				new PublicKey( system, new int[] { 2, 3 } ) );
		
		PublicKey publicKey = new PublicKey( system, new int[] { 1, 4 } );
		assertEquals( 33, dev1.calculateKey( publicKey ) );
		assertEquals( 18, dev2.calculateKey( publicKey ) );
		assertEquals( 41, dev3.calculateKey( publicKey ) );
		assertEquals( 26, dev4.calculateKey( publicKey ) );
	}
	
	public void testRoundTripPublicKey() {
		HdcpSystem system = new HdcpSystem(4);
		PublicKey publicKey = new PublicKey( system, new int[] { 1, 4 } );

		assertEquals( 2, publicKey.getPublicKeyItems().length );
		assertEquals( 1, publicKey.getPublicKeyItems()[ 0 ] );
		assertEquals( 4, publicKey.getPublicKeyItems()[ 1 ] );
	}
}
